using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Imaging;

namespace EMFdemo
{
    public partial class MainForm : Form
    {
        public MainForm()
        {
            InitializeComponent();
        }

        private void draw(Graphics g)
        {
            g.FillEllipse(Brushes.Blue, 12.0f, 23.0f, 34.0f, 45.0f);
            g.RotateTransform(-12.0f);
            g.DrawString("Hello World!", new Font("Impact", 23.4f), Brushes.Red, new PointF(34.0f, 87.0f));
        }

        protected override void OnPaint(PaintEventArgs e)
        {
            base.OnPaint(e);
            draw(e.Graphics);
        }

        // A hack to write actual vector graphics EMF files
        // as opposed to the bitmap files you get from using Metafile.Save.
        private void generateButton_Click(object sender, EventArgs e)
        {
            DialogResult r = saveFileDialog.ShowDialog();
            if (r == DialogResult.OK)
            {
                Bitmap bitmapDummy = new Bitmap(1, 1, PixelFormat.Format24bppRgb);
                Graphics graphicsDummy = Graphics.FromImage(bitmapDummy);
                IntPtr hDC = graphicsDummy.GetHdc();
                Metafile mf = new Metafile(saveFileDialog.FileName, hDC);
                graphicsDummy.ReleaseHdc(hDC);
                Graphics g = Graphics.FromImage(mf);
                draw(g); // same drawing commands as used on the screen
                g.Dispose();
                mf.Dispose();
            }
        }
    }
}