﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.IO;
using System.Windows.Xps; // requires a reference to the ReachFramework and System.Printing
using System.Windows.Xps.Packaging; // requires a reference to the ReachFramework

namespace XPSdemo
{
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            Ellipse e = new Ellipse() { Width = 234, Height = 123, Fill = Brushes.Blue };
            Canvas.SetLeft(e, 89);
            Canvas.SetTop(e, 56);
            myCanvas.Children.Add(e);

            TextBlock t = new TextBlock();
            t.FontFamily = new FontFamily("Impact");
            t.FontSize = 34.56;
            t.Foreground = Brushes.Red;
            t.Text = "Hello World!";
            t.RenderTransform = new RotateTransform { Angle = -23.45, CenterX = 100.0, CenterY = 80.0 };
            myCanvas.Children.Add(t);
        }

        private void generateButton_Click(object sender, RoutedEventArgs e)
        {
            Microsoft.Win32.SaveFileDialog d = new Microsoft.Win32.SaveFileDialog();
            d.Filter = "XPS files|*.xps";
            bool? r = d.ShowDialog();
            if (r.HasValue && r.Value)
            {
                XpsDocument doc = new XpsDocument(d.FileName, FileAccess.ReadWrite);
                XpsDocumentWriter docWriter = XpsDocument.CreateXpsDocumentWriter(doc);
                docWriter.Write(myCanvas);
                doc.Close();
            }
        }
    }
}
